--WeightStationWoodLogs.lua
--
--Autor: kenny456(kenny4566@seznam.cz)
--Version: 1.0
--Date: 13.3.2018 (FS17 version)
--

WeightStationWoodLogs = {};
WeightStationWoodLogs_directory = g_currentModDirectory;

WeightStationWoodLogs_mt = Class(WeightStationWoodLogs, Placeable);
InitObjectClass(WeightStationWoodLogs, "WeightStationWoodLogs");

function WeightStationWoodLogs:new(isServer, isClient, customMt)
    local self = Placeable:new(isServer, isClient, WeightStationWoodLogs_mt);
    registerObjectClassName(self, "WeightStationWoodLogs");
    self.wwl = {};
    self.wwl.hasMass = false
    if g_currentMission.WeightStationWoodLogs == nil then
        g_currentMission.WeightStationWoodLogs = {};
        table.insert(g_currentMission.WeightStationWoodLogs,self);
    else
        table.insert(g_currentMission.WeightStationWoodLogs,self);
    end;
    return self;
end;

function WeightStationWoodLogs:delete()
    removeTrigger(self.trigger);
    self.active = false;
    unregisterObjectClassName(self);
    for i,tself in pairs(g_currentMission.WeightStationWoodLogs) do
        if tself == self then
            table.remove(g_currentMission.WeightStationWoodLogs,i);
            break;
        end;
    end;
    WeightStationWoodLogs:superClass().delete(self);
end;

function WeightStationWoodLogs:deleteFinal()
    WeightStationWoodLogs:superClass().deleteFinal(self);
end;

function WeightStationWoodLogs:load(xmlFilename, x,y,z, rx,ry,rz, initRandom)
    if not WeightStationWoodLogs:superClass().load(self, xmlFilename, x,y,z, rx,ry,rz, initRandom) then
        return false;
    end;
    self.active = false;
    if not moveMode then
        self.wwl.hudInfoPosX = 0.84
        self.wwl.hudInfoPosY = 0.22
        self.wwl.hudInfoSizeX = 0.156
        self.wwl.hudInfoSizeY = 0.295
        self.wwl.hudInfoShift = 0.09
        self.wwl.hud = Overlay:new("WeightStationWoodLogs", Utils.getFilename("Info_hud.dds", WeightStationWoodLogs_directory), self.wwl.hudInfoPosX, self.wwl.hudInfoPosY, self.wwl.hudInfoSizeX, self.wwl.hudInfoSizeY);
        self.wwl.info = "";
        self.wwl.info2 = "";
        self.wwl.info3 = "";
        self.wwl.info4 = "";
        self.wwl.showHud = false;
        self.wwl.weightTotal = 0;
        self.wwl.weightVehicle = 0;
        self.wwl.weightTrailer = 0;
        self.wwl.weightWoods = 0;
        self.wwl.weightWoodChips = 0;
        self.wwl.weightBoardPallets = 0;
        self.wwl.weightOtherPallets = 0;
        self.wwl.statsSession = {};
        self.wwl.statsSession['vehicles'] = {0,0};
        self.wwl.statsSession['woods'] = {0,0};
        self.wwl.statsSession['woodChips'] = {0,0};
        self.wwl.statsSession['otherFruit'] = {0,0};
        self.wwl.statsSession['boardPallets'] = {0,0};
        self.wwl.statsSession['otherPallets'] = {0,0};
        self.wwl.statsTotal = {};
        self.wwl.statsTotal['vehicles'] = {0,0};
        self.wwl.statsTotal['woods'] = {0,0};
        self.wwl.statsTotal['woodChips'] = {0,0};
        self.wwl.statsTotal['otherFruit'] = {0,0};
        self.wwl.statsTotal['boardPlallets'] = {0,0};
        self.wwl.statsTotal['otherPallets'] = {0,0};
        self.active = true;
        self.trigger = Utils.indexToObject(self.nodeId,"0");
        addTrigger(self.trigger, "triggerCallback", self);
        self.wwl.mass = 0;
        self.wwl.massVehicle = 0;
        self.wwl.massTrailer = 0;
        self.wwl.massWoods = 0;
        self.wwl.massWoodChips = 0;
        self.wwl.massBoardPallets = 0;
        self.wwl.massOtherPallets = 0;
        self.wwl.volWoods = 0;
        self.wwl.volBoardPallets = 0;
        self.wwl.volOtherPallets = 0;
        self.wwl.vehicles = {};
        self.wwl.trailer = {};
        self.wwl.woods = {};
        self.wwl.boardPallets = {};
        self.wwl.otherPallets = {};
        self.advStats = false
        
        local dig1,dig2,dig3,dig4 = {},{},{},{}
        dig1[1] = Utils.indexToObject(self.nodeId,"1|0|3");
        dig2[1] = Utils.indexToObject(self.nodeId,"1|0|2");
        dig3[1] = Utils.indexToObject(self.nodeId,"1|0|1");
        dig4[1] = Utils.indexToObject(self.nodeId,"1|0|0");
        dig1[2] = Utils.indexToObject(self.nodeId,"2|0|3");
        dig2[2] = Utils.indexToObject(self.nodeId,"2|0|2");
        dig3[2] = Utils.indexToObject(self.nodeId,"2|0|1");
        dig4[2] = Utils.indexToObject(self.nodeId,"2|0|0");
        self.Numbers = {{},{}};
        for j = 1, 2, 1 do
            for ii = 0, 3, 1 do
                table.insert(self.Numbers[j],ii,{});
                for i = 0, 9, 1 do
                    local object = dig1[j];
                    if ii == 0 then
                        object = dig1[j];
                    elseif ii == 1 then
                        object = dig2[j];
                    elseif ii == 2 then
                        object = dig3[j]
                    else
                        object = dig4[j];
                    end;
                    table.insert(self.Numbers[j][ii],i,{Utils.indexToObject(object,tostring(i))});
                    setVisibility(self.Numbers[j][ii][i][1],false);
                end;
            end;
        end;
    end;
    return true;
end;

function WeightStationWoodLogs:update(dt)
    if self.active then
        if self.wwl.mass ~= nil and self.wwl.mass > 0 then
            self.wwl.hasMass = true
        else
            self.wwl.hasMass = false
        end
        self.wwl.mass = self.wwl.massVehicle + self.wwl.massWoodChips + self.wwl.massTrailer + self.wwl.massWoods + self.wwl.massBoardPallets + self.wwl.massOtherPallets
        local delta = dt / 16.616
        
        --if true then
            if self.wwl.weightTotal < math.floor(self.wwl.mass / 1.1) then
                self.wwl.weightTotal = self.wwl.weightTotal + ((self.wwl.mass / 18) * (dt / 16.62))
            elseif self.wwl.weightTotal < math.floor(self.wwl.mass / 1.001) then
                if self.wwl.mass < 15 then
                    self.wwl.weightTotal = self.wwl.weightTotal + ((self.wwl.mass / 118) * (dt / 16.62)) --118
                else
                    self.wwl.weightTotal = self.wwl.weightTotal + ((self.wwl.mass / 1018) * (dt / 16.62)) --118
                end
            elseif self.wwl.weightTotal < self.wwl.mass then
                self.wwl.weightTotal = self.wwl.weightTotal + (0.01 * (dt / 16.62)) --118
            else
                self.wwl.weightTotal = self.wwl.mass
            end
            
            if self.wwl.weightVehicle < math.floor(self.wwl.massVehicle / 1.1) then
                self.wwl.weightVehicle = self.wwl.weightVehicle + (self.wwl.massVehicle / 18 * delta)
            elseif self.wwl.weightVehicle < math.floor(self.wwl.massVehicle / 1.001) then
                if self.wwl.massVehicle < 15 then
                    self.wwl.weightVehicle = self.wwl.weightVehicle + (self.wwl.massVehicle / 118 * delta)
                else
                    self.wwl.weightVehicle = self.wwl.weightVehicle + (self.wwl.massVehicle / 1018 * delta)
                end
            elseif self.wwl.weightVehicle < self.wwl.massVehicle then
                self.wwl.weightVehicle = self.wwl.weightVehicle + (0.01 * delta)
            else
                self.wwl.weightVehicle = self.wwl.massVehicle
            end
            
            if self.wwl.weightWoodChips < math.floor(self.wwl.massWoodChips / 1.1) then
                self.wwl.weightWoodChips = self.wwl.weightWoodChips + (self.wwl.massWoodChips / 18 * delta)
            elseif self.wwl.weightWoodChips < math.floor(self.wwl.massWoodChips / 1.001) then
                if self.wwl.massWoodChips < 15 then
                    self.wwl.weightWoodChips = self.wwl.weightWoodChips + (self.wwl.massWoodChips / 118 * delta)
                else
                    self.wwl.weightWoodChips = self.wwl.weightWoodChips + (self.wwl.massWoodChips / 1018 * delta)
                end
            elseif self.wwl.weightWoodChips < self.wwl.massWoodChips then
                self.wwl.weightWoodChips = self.wwl.weightWoodChips + (0.01 * delta)
            else
                self.wwl.weightWoodChips = self.wwl.massWoodChips
            end
            
            if self.wwl.weightTrailer < math.floor(self.wwl.massTrailer / 1.1) then
                self.wwl.weightTrailer = self.wwl.weightTrailer + (self.wwl.massTrailer / 18 * delta)
            elseif self.wwl.weightTrailer < math.floor(self.wwl.massTrailer / 1.001) then
                if self.wwl.massTrailer < 15 then
                    self.wwl.weightTrailer = self.wwl.weightTrailer + (self.wwl.massTrailer / 118 * delta)
                else
                    self.wwl.weightTrailer = self.wwl.weightTrailer + (self.wwl.massTrailer / 1018 * delta)
                end
            elseif self.wwl.weightTrailer < self.wwl.massTrailer then
                self.wwl.weightTrailer = self.wwl.weightTrailer + (0.01 * delta)
            else
                self.wwl.weightTrailer = self.wwl.massTrailer
            end
            
            if self.wwl.weightWoods < math.floor(self.wwl.massWoods / 1.1) then
                self.wwl.weightWoods = self.wwl.weightWoods + (self.wwl.massWoods / 18 * delta)
            elseif self.wwl.weightWoods < math.floor(self.wwl.massWoods / 1.001) then
                if self.wwl.massWoods < 15 then
                    self.wwl.weightWoods = self.wwl.weightWoods + (self.wwl.massWoods / 118 * delta)
                else
                    self.wwl.weightWoods = self.wwl.weightWoods + (self.wwl.massWoods / 1018 * delta)
                end
            elseif self.wwl.weightWoods < self.wwl.massWoods then
                self.wwl.weightWoods = self.wwl.weightWoods + (0.01 * delta)
            else
                self.wwl.weightWoods = self.wwl.massWoods
            end
            
            if self.wwl.weightBoardPallets < math.floor(self.wwl.massBoardPallets / 1.1) then
                self.wwl.weightBoardPallets = self.wwl.weightBoardPallets + (self.wwl.massBoardPallets / 18 * delta)
            elseif self.wwl.weightBoardPallets < math.floor(self.wwl.massBoardPallets / 1.001) then
                if self.wwl.massBoardPallets < 15 then
                    self.wwl.weightBoardPallets = self.wwl.weightBoardPallets + (self.wwl.massBoardPallets / 118 * delta)
                else
                    self.wwl.weightBoardPallets = self.wwl.weightBoardPallets + (self.wwl.massBoardPallets / 1018 * delta)
                end
            elseif self.wwl.weightBoardPallets < self.wwl.massBoardPallets then
                self.wwl.weightBoardPallets = self.wwl.weightBoardPallets + (0.01 * delta)
            else
                self.wwl.weightBoardPallets = self.wwl.massBoardPallets
            end
            
            if self.wwl.weightOtherPallets < math.floor(self.wwl.massOtherPallets / 1.1) then
                self.wwl.weightOtherPallets = self.wwl.weightOtherPallets + (self.wwl.massOtherPallets / 18 * delta)
            elseif self.wwl.weightOtherPallets < math.floor(self.wwl.massOtherPallets / 1.001) then
                if self.wwl.massOtherPallets < 15 then
                    self.wwl.weightOtherPallets = self.wwl.weightOtherPallets + (self.wwl.massOtherPallets / 118 * delta)
                else
                    self.wwl.weightOtherPallets = self.wwl.weightOtherPallets + (self.wwl.massOtherPallets / 1018 * delta)
                end
            elseif self.wwl.weightOtherPallets < self.wwl.massOtherPallets then
                self.wwl.weightOtherPallets = self.wwl.weightOtherPallets + (0.01 * delta)
            else
                self.wwl.weightOtherPallets = self.wwl.massOtherPallets
            end
        --end
        
        --if true then
            local mass = string.format("%.1f",self.wwl.weightTotal);
            self.wwl.info = 'WeightStation Woodlogs\n------------------------------------\n';
            self.wwl.info2 = '\n\n';
            self.wwl.info3 = '\n\n';
            self.wwl.info4 = '\n\n\n';
            
            if self.wwl.weightVehicle > 0 then
                self.wwl.info = self.wwl.info .. 'Vehicle :\n';
                self.wwl.info2 = self.wwl.info2 .. string.format("%.1f",self.wwl.weightVehicle) .. ' t\n';
                self.wwl.info3 = self.wwl.info3 .. '\n'
                self.wwl.info4 = self.wwl.info4 .. '\n'
            end
            if self.wwl.weightWoods > 0 then
                local count = 0
                for _ in pairs(self.wwl.woods) do count = count + 1 end
                self.wwl.info = self.wwl.info .. 'WoodLogs (' .. count .. ') :\n';
                self.wwl.info2 = self.wwl.info2 .. string.format("%.1f",self.wwl.weightWoods) .. ' t\n';
                self.wwl.info3 = self.wwl.info3 .. 'vol: ' .. string.format("%.1f",self.wwl.volWoods) .. ' m3\n'
            end
            if self.wwl.weightWoodChips > 0 then
                self.wwl.info = self.wwl.info .. 'WoodChips :\n';
                self.wwl.info2 = self.wwl.info2 .. string.format("%.1f",self.wwl.weightWoodChips) .. ' t\n';
                self.wwl.info3 = self.wwl.info3 .. '\n'
                self.wwl.info4 = self.wwl.info4 .. '\n'
            end
            if self.wwl.weightBoardPallets > 0 then
                local count = 0
                for _ in pairs(self.wwl.boardPallets) do count = count + 1 end
                self.wwl.info = self.wwl.info .. 'Board Pallets (' .. count .. ') :\n';
                self.wwl.info2 = self.wwl.info2 .. string.format("%.1f",self.wwl.weightBoardPallets) .. ' t\n';
                self.wwl.info3 = self.wwl.info3 .. 'vol: ' .. string.format("%.1f",self.wwl.volBoardPallets)..' m3\n'
            end
            if self.wwl.weightOtherPallets > 0 then
                local count = 0
                for _ in pairs(self.wwl.otherPallets) do count = count + 1 end
                self.wwl.info = self.wwl.info .. 'Other Pallets (' .. count .. ') :\n';
                self.wwl.info2 = self.wwl.info2 .. string.format("%.1f",self.wwl.weightOtherPallets) .. ' t\n';
                self.wwl.info3 = self.wwl.info3 .. 'vol: ' .. string.format("%.1f",self.wwl.volOtherPallets)..' m3\n'
            end
            if self.wwl.weightTrailer > 0 then
                self.wwl.info = self.wwl.info .. 'Other fruit: \n';
                self.wwl.info2 = self.wwl.info2 .. string.format("%.1f",self.wwl.weightTrailer) .. ' t\n';
                self.wwl.info3 = self.wwl.info3 .. '\n'
            end
        --end
        local statsType
        if self.advStats == true then
            statsType = 2
        else
            statsType = 1
        end
        self.wwl.info = self.wwl.info .. '---------------------------------------------------------\n';
        self.wwl.info2 = self.wwl.info2 .. '\n';
        self.wwl.info3 = self.wwl.info3 .. '\n\n'
        self.wwl.info = self.wwl.info .. 'Total :\n';
        self.wwl.info = self.wwl.info .. '\n';
        self.wwl.info2 = self.wwl.info2 .. string.format("%.1f",self.wwl.weightTotal) .. ' t\n';
        self.wwl.info = self.wwl.info .. 'Statistics :';
        self.wwl.info = self.wwl.info .. '\n';
        self.wwl.info2 = self.wwl.info2 .. '\nThis Session\n\n';
        self.wwl.info3 = self.wwl.info3 .. '\nTotal\n\n';
        self.wwl.info = self.wwl.info .. '---------------------------------------------------------\n';
        self.wwl.info = self.wwl.info .. 'Vehicles :\n';
        self.wwl.info2 = self.wwl.info2 .. string.format((statsType == 1 and '%.1f' or '%.0f'),self.wwl.statsSession['vehicles'][statsType]) .. (statsType == 1 and ' t' or ' vehicles') .. '\n';
        self.wwl.info3 = self.wwl.info3 .. string.format((statsType == 1 and '%.1f' or '%.0f'),self.wwl.statsTotal['vehicles'][statsType]) .. (statsType == 1 and ' t' or ' vehicles') .. '\n';
        self.wwl.info = self.wwl.info .. 'WoodLogs :\n';
        self.wwl.info2 = self.wwl.info2 .. string.format((statsType == 1 and '%.1f' or '%.0f'),self.wwl.statsSession['woods'][statsType]) .. (statsType == 1 and ' t' or ' logs') .. '\n';
        self.wwl.info3 = self.wwl.info3 .. string.format((statsType == 1 and '%.1f' or '%.0f'),self.wwl.statsTotal['woods'][statsType]) .. (statsType == 1 and ' t' or ' logs') .. '\n';
        self.wwl.info = self.wwl.info .. 'WoodChips :\n';
        self.wwl.info2 = self.wwl.info2 .. string.format((statsType == 1 and '%.1f' or '%.0f'),self.wwl.statsSession['woodChips'][statsType]) .. (statsType == 1 and ' t' or ' trailers') .. '\n';
        self.wwl.info3 = self.wwl.info3 .. string.format((statsType == 1 and '%.1f' or '%.0f'),self.wwl.statsTotal['woodChips'][statsType]) .. (statsType == 1 and ' t' or ' trailers') .. '\n';
        self.wwl.info = self.wwl.info .. 'Other Fruit :\n';
        self.wwl.info2 = self.wwl.info2 .. string.format((statsType == 1 and '%.1f' or '%.0f'),self.wwl.statsSession['otherFruit'][statsType]) .. (statsType == 1 and ' t' or ' trailers') .. '\n';
        self.wwl.info3 = self.wwl.info3 .. string.format((statsType == 1 and '%.1f' or '%.0f'),self.wwl.statsTotal['otherFruit'][statsType]) .. (statsType == 1 and ' t' or ' trailers') .. '\n';
        self.wwl.info = self.wwl.info .. 'Board Pallets :\n';
        self.wwl.info2 = self.wwl.info2 .. string.format((statsType == 1 and '%.1f' or '%.0f'),self.wwl.statsSession['boardPallets'][statsType]) .. (statsType == 1 and ' t' or ' pallets') .. '\n';
        self.wwl.info3 = self.wwl.info3 .. string.format((statsType == 1 and '%.1f' or '%.0f'),self.wwl.statsTotal['boardPlallets'][statsType]) .. (statsType == 1 and ' t' or ' pallets') .. '\n';
        self.wwl.info = self.wwl.info .. 'Other Pallets :';
        self.wwl.info2 = self.wwl.info2 .. string.format((statsType == 1 and '%.1f' or '%.0f'),self.wwl.statsSession['otherPallets'][statsType]) .. (statsType == 1 and ' t' or ' pallets') .. '\n';
        self.wwl.info3 = self.wwl.info3 .. string.format((statsType == 1 and '%.1f' or '%.0f'),self.wwl.statsTotal['otherPallets'][statsType]) .. (statsType == 1 and ' t' or ' pallets') .. '\n';

        if self.isClient then
            if g_currentMission.controlledVehicle ~= nil and self.wwl.vehicles ~= nil and self.wwl.vehicles ~= 0 then
                local count = 0
                for _ in pairs(self.wwl.vehicles) do count = count + 1 end
                if count > 0 then
                    for k, vehicle in pairs(self.wwl.vehicles) do
                        if vehicle ~= nil and g_currentMission.controlledVehicle == vehicle then
                            self.wwl.showHud = true
                            break
                        else
                            self.wwl.showHud = false
                        end
                    end
                else
                    self.wwl.showHud = false
                end
            else
                self.wwl.showHud = false
            end
        end
        
        if self.wwl.weightTotal > 999.99 then
            mass = "999.9";
        end;
        if self.wwl.weightTotal < 10 then
            mass = "00"..mass;
        elseif self.wwl.weightTotal < 100 then
             mass = "0"..mass;
        end;
        local numbers = {"0","0","0","0"};
        for i = 1, 4, 1 do
            local ii = i;
            if(ii > 3) then
                ii = (ii+1)
            end;
            numbers[i] = string.sub(mass,ii,ii);
        end;
        for i = 0, 3, 1 do
            for ii = 0, 9, 1 do
                if (tostring(ii) == numbers[(i+1)]) then
                    setVisibility(self.Numbers[1][i][ii][1], true);
                    setVisibility(self.Numbers[2][i][ii][1], true);
                else
                    setVisibility(self.Numbers[1][i][ii][1], false);
                    setVisibility(self.Numbers[2][i][ii][1], false);
                end;
            end;
        end;
    end;
	if self.isClient then
		if self.wwl.hasMass and self.wwl.showHud == true then
            self.wwl.hud:render();
            renderText(self.wwl.hudInfoPosX + 0.005, self.wwl.hudInfoPosY + self.wwl.hudInfoSizeY - 0.025, 0.014, self.wwl.info);
            setTextAlignment(RenderText.ALIGN_RIGHT);
            renderText(self.wwl.hudInfoPosX + 0.098, self.wwl.hudInfoPosY + self.wwl.hudInfoSizeY - 0.025, 0.014, self.wwl.info2);
            renderText(self.wwl.hudInfoPosX + 0.150, self.wwl.hudInfoPosY + self.wwl.hudInfoSizeY - 0.025, 0.014, self.wwl.info3);
            setTextAlignment(RenderText.ALIGN_LEFT);
			
			g_currentMission:addHelpButtonText(g_i18n:getText("input_WWL_RESET_SESSION"), InputBinding.WWL_RESET_SESSION);
			g_currentMission:addHelpButtonText(g_i18n:getText("input_WWL_RESET_TOTAL"), InputBinding.WWL_RESET_TOTAL);
			g_currentMission:addHelpButtonText(g_i18n:getText("input_WWL_SWITCH_STATS"), InputBinding.WWL_SWITCH_STATS);
			if InputBinding.hasEvent(InputBinding.WWL_RESET_SESSION) then
				for k,v in pairs(self.wwl.statsSession) do
					self.wwl.statsSession[k] = {0,0}
				end
			end;
			if InputBinding.hasEvent(InputBinding.WWL_RESET_TOTAL) then
				for k,v in pairs(self.wwl.statsTotal) do
					self.wwl.statsTotal[k] = {0,0}
				end
			end;
			if InputBinding.hasEvent(InputBinding.WWL_SWITCH_STATS) then
				self.advStats = not self.advStats
			end;
		end;
	end	
end;

function WeightStationWoodLogs:getSaveAttributesAndNodes(nodeIdent)
    local attributes, nodes = "","";
    attributes, nodes = WeightStationWoodLogs:superClass().getSaveAttributesAndNodes(self, nodeIdent);
    
    for k,v in pairs (self.wwl.statsTotal) do
        if 0 < nodes.len(nodes) then
            nodes = nodes .. "\n"
        end
        nodes = nodes..nodeIdent..'<statsTotal name="'..k..'" level="'..v[1]..'" count="'..v[2]..'"/>';
    end
    
    return attributes,nodes;
end
function WeightStationWoodLogs:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
    WeightStationWoodLogs:superClass().loadFromAttributesAndNodes(self, xmlFile, key, resetVehicles)
    
    local i = 0
    while true do
        local statsTotalKey = key .. string.format(".statsTotal(%d)", i)
        if not hasXMLProperty(xmlFile, statsTotalKey) then
            break
        end
        local name = getXMLString(xmlFile, statsTotalKey .. "#name")
        local level = getXMLFloat(xmlFile, statsTotalKey .. "#level")
        local count = getXMLFloat(xmlFile, statsTotalKey .. "#count")
        if name ~= nil and level ~= nil and count ~= nil and self.wwl.statsTotal[name] ~= nil then
            self.wwl.statsTotal[name][1] = level
            self.wwl.statsTotal[name][2] = count
        end
        i = i + 1
    end    
    return true;
end

function WeightStationWoodLogs:triggerCallback(triggerId,otherId,onEnter,onLeave,onStay)
    if self.active then
        if onEnter then
            local vehicle = g_currentMission.nodeToVehicle[otherId];
            --if g_currentMission:getIsServer() then
				if vehicle ~= nil and self.wwl.vehicles[vehicle] == nil then
					self.wwl.massVehicle =  self.wwl.massVehicle + getMass(vehicle.components[1].node);
					self.wwl.vehicles[vehicle] = vehicle;
					self.wwl.statsSession['vehicles'][1] = self.wwl.statsSession['vehicles'][1] + getMass(vehicle.components[1].node);
					self.wwl.statsTotal['vehicles'][1] = self.wwl.statsTotal['vehicles'][1] + getMass(vehicle.components[1].node);
					if vehicle.isControlled then
						self.wwl.statsSession['vehicles'][2] = self.wwl.statsSession['vehicles'][2] + 1;
						self.wwl.statsTotal['vehicles'][2] = self.wwl.statsTotal['vehicles'][2] + 1;
					end
				end;
			--end
            local trailer = g_currentMission.objectToTrailer[otherId];
			--if g_currentMission:getIsServer() then
				if trailer ~= nil and self.wwl.trailer[trailer] == nil then
					local trailerFillLevel, trailerFillType = 0,0
					if trailer.getFillLevelInformation ~= nil then
						local fillLevelInformations = {};
						trailer:getFillLevelInformation(fillLevelInformations);			
						for i,fillLevelInformation in pairs(fillLevelInformations) do
							trailerFillLevel = fillLevelInformation.fillLevel;
							trailerFillType = fillLevelInformation.fillType;				
						end
					end;
					if trailerFillLevel ~= nil and (trailerFillLevel/1000) ~= 0 and trailerFillType ~= FillUtil.FILLTYPE_UNKNOWN then
						if trailerFillType == FillUtil.FILLTYPE_WOODCHIPS then
							self.wwl.massWoodChips = self.wwl.massWoodChips + (trailerFillLevel/1000);
							self.wwl.statsSession['woodChips'][1] = self.wwl.statsSession['woodChips'][1] + (trailerFillLevel/1000);
							self.wwl.statsSession['woodChips'][2] = self.wwl.statsSession['woodChips'][2] + 1;
							self.wwl.statsTotal['woodChips'][1] = self.wwl.statsTotal['woodChips'][1] + (trailerFillLevel/1000);
							self.wwl.statsTotal['woodChips'][2] = self.wwl.statsTotal['woodChips'][2] + 1;
						else
							self.wwl.massTrailer = self.wwl.massTrailer + (trailerFillLevel/1000);
							self.wwl.statsSession['otherFruit'][1] = self.wwl.statsSession['otherFruit'][1] + (trailerFillLevel/1000);
							self.wwl.statsSession['otherFruit'][2] = self.wwl.statsSession['otherFruit'][2] + 1
							self.wwl.statsTotal['otherFruit'][1] = self.wwl.statsTotal['otherFruit'][1] + (trailerFillLevel/1000);
							self.wwl.statsTotal['otherFruit'][2] = self.wwl.statsTotal['otherFruit'][2] + 1
						end
					end;
					self.wwl.trailer[trailer] = 1;
				end;
			--end
            local splitType = SplitUtil.splitTypes[getSplitType(otherId)];
			--if g_currentMission:getIsServer() then
				if splitType ~= nil and self.wwl.woods[otherId] == nil then
					self.wwl.massWoods = self.wwl.massWoods + getMass(otherId);
					self.wwl.volWoods = self.wwl.volWoods + getVolume(otherId);
					self.wwl.statsSession['woods'][1] = self.wwl.statsSession['woods'][1] + getMass(otherId);
					self.wwl.statsSession['woods'][2] = self.wwl.statsSession['woods'][2] + 1;
					self.wwl.statsTotal['woods'][1] = self.wwl.statsTotal['woods'][1] + getMass(otherId);
					self.wwl.statsTotal['woods'][2] = self.wwl.statsTotal['woods'][2] + 1
					self.wwl.woods[otherId] = 1;
				end
			--end
            local object = g_currentMission:getNodeObject(otherId)
			--if g_currentMission:getIsServer() then
				if object ~= nil and object.isa(object, FillablePallet) and self.wwl.boardPallets[object] == nil and self.wwl.otherPallets[object] == nil then
					local fillType = getUserAttribute(object.nodeId, "fillType");
					--print(getName(object.nodeId))
					--print(fillType)
					if getName(object.nodeId) == 'boardPallet' or fillType == 'boards' then
						self.wwl.massBoardPallets = self.wwl.massBoardPallets + getMass(otherId);
						self.wwl.volBoardPallets = self.wwl.volBoardPallets + getVolume(otherId)
						self.wwl.boardPallets[object] = 1
						self.wwl.statsSession['boardPallets'][1] = self.wwl.statsSession['boardPallets'][1] + getMass(otherId);
						self.wwl.statsSession['boardPallets'][2] = self.wwl.statsSession['boardPallets'][2] + 1
						self.wwl.statsTotal['boardPlallets'][1] = self.wwl.statsTotal['boardPlallets'][1] + getMass(otherId);
						self.wwl.statsTotal['boardPlallets'][2] = self.wwl.statsTotal['boardPlallets'][2] + 1
					else
						self.wwl.massOtherPallets = self.wwl.massOtherPallets + getMass(otherId);
						self.wwl.volOtherPallets = self.wwl.volOtherPallets + getVolume(otherId)
						self.wwl.otherPallets[object] = 1
						self.wwl.statsSession['otherPallets'][1] = self.wwl.statsSession['otherPallets'][1] + getMass(otherId);
						self.wwl.statsSession['otherPallets'][2] = self.wwl.statsSession['otherPallets'][2] + 1
						self.wwl.statsTotal['otherPallets'][1] = self.wwl.statsTotal['otherPallets'][1] + getMass(otherId);
						self.wwl.statsTotal['otherPallets'][2] = self.wwl.statsTotal['otherPallets'][2] + 1
					end
				end
			--end
        elseif onLeave then
            local vehicle = g_currentMission.nodeToVehicle[otherId];
            --if g_currentMission:getIsServer() then
				if vehicle ~= nil and self.wwl.vehicles[vehicle] ~= nil then
					self.wwl.massVehicle = math.max((self.wwl.massVehicle - getMass(vehicle.components[1].node)),0);
					self.wwl.vehicles[vehicle] = nil;
				end;
			--end
            local trailer = g_currentMission.objectToTrailer[otherId];
            --if g_currentMission:getIsServer() then
				if trailer ~= nil and self.wwl.trailer[trailer] ~= nil then
					local trailerFillLevel, trailerFillType = 0,0
					if trailer.getFillLevelInformation ~= nil then
						local fillLevelInformations = {};
						trailer:getFillLevelInformation(fillLevelInformations);			
						for i,fillLevelInformation in pairs(fillLevelInformations) do
							trailerFillLevel = fillLevelInformation.fillLevel;
							trailerFillType = fillLevelInformation.fillType;				
						end
					end;
					if trailerFillLevel ~= nil and (trailerFillLevel/1000) ~= 0 then
						if trailerFillType == FillUtil.FILLTYPE_WOODCHIPS then
							self.wwl.massWoodChips = math.max((self.wwl.massWoodChips - (trailerFillLevel/1000)),0);
						else
							self.wwl.massTrailer = math.max((self.wwl.massTrailer - (trailerFillLevel/1000)),0);
						end
					end;
					self.wwl.trailer[trailer] = nil;
				end;
			--end
            local splitType = SplitUtil.splitTypes[getSplitType(otherId)];
            --if g_currentMission:getIsServer() then
				if splitType ~= nil and self.wwl.woods[otherId] ~= nil then
					self.wwl.massWoods = math.max(self.wwl.massWoods - getMass(otherId),0);
					self.wwl.volWoods = math.max(self.wwl.volWoods - getVolume(otherId),0);
					self.wwl.woods[otherId] = nil;
				end
			--end
            local object = g_currentMission:getNodeObject(otherId)
            --if g_currentMission:getIsServer() then
				if object ~= nil and object.isa(object, FillablePallet) and (self.wwl.boardPallets[object] ~= nil or self.wwl.otherPallets[object] ~= nil) then
					local fillType = getUserAttribute(object.nodeId, "fillType");
					if getName(object.nodeId) == 'boardPallet' or fillType == 'boards' then
						self.wwl.massBoardPallets = math.max(self.wwl.massBoardPallets - getMass(otherId),0);
						self.wwl.volBoardPallets = math.max(self.wwl.volBoardPallets - getVolume(otherId),0);
						self.wwl.boardPallets[object] = nil
					else
						self.wwl.massOtherPallets = math.max(self.wwl.massOtherPallets - getMass(otherId),0);
						self.wwl.volOtherPallets = math.max(self.wwl.volOtherPallets - getVolume(otherId),0);
						self.wwl.otherPallets[object] = nil
					end
				end
			--end
        end;
    end;
end;
registerPlaceableType("WeightStationWoodLogs", WeightStationWoodLogs);